<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:fn="http://java.sun.com/jsp/jstl/functions"
	xmlns:fmt="http://java.sun.com/jsp/jstl/fmt">

	<h1>
		<small>Lançamento de Titulos</small>
	</h1>
	<h:form id="frmTotais">
		<p:panelGrid columns="2" id="painel-result" style="margin-top: 20px"
			layout="grid" columnClasses="ui-grid-col-9,ui-grid-col-3,">
			<p:outputLabel value="Valores Em Aberto até o Momento:" />
			<p:outputLabel value="#{lancamentoController.valorEmAberto}"
				styleClass="aberto" />
			<p:outputLabel value="Valores Baixados até o Momento:" />
			<p:outputLabel value="#{lancamentoController.valoresPagos}"
				styleClass="baixado" />
			<p:outputLabel value="Valores Vencidos até o Momento:" />
			<p:outputLabel value="#{lancamentoController.valoresVencidos}"
				styleClass="vencido" />
		</p:panelGrid>
	</h:form>
	<p:tabView id="tabLancamentos">
		<p:ajax event="tabChange" listener="#{lancamentoController.onTabChange}" process="@this"/>
		<p:tab title="Lancamentos a Receber">
			<h:form id="frmCadRec">
				<p:panel>
					<p:toolbar id="tbOpcoes" style="margin-top: 20px">
						<p:toolbarGroup>
							<p:commandButton value="Salvar" id="botaoSalvar"
								styleClass="corVerde" action="#{lancamentoController.salvar}"
								rendered="#{lancamentoController.ativo}"
								update="frmCadRec :frmTotais:painel-result growl"
								process="@this painel" />

							<p:commandButton value="Novo" id="botaoNovo" styleClass="corAzul"
								actionListener="#{lancamentoController.ativar}"
								rendered="#{!lancamentoController.ativo}"
								update="tbOpcoes painel growl" process="@this" />

							<p:commandButton value="Cancelar" id="botaoCancelar"
								styleClass="corVermelho"
								rendered="#{lancamentoController.ativo}"
								actionListener="#{lancamentoController.desativar}"
								update="tbOpcoes painel" process="@this">
								<p:resetInput target="painel" />
							</p:commandButton>
						</p:toolbarGroup>
					</p:toolbar>
				</p:panel>
				<p:panelGrid columns="4" id="painel" style="margin-top: 20px"
					styleClass="semBorda">

					<p:outputLabel value="Cliente: " for="cliente" />
					<p:autoComplete id="cliente"
						disabled="#{!lancamentoController.ativo}"
						completeMethod="#{lancamentoController.listarClientes}" size="80"
						value="#{lancamentoController.lancamento.cliente}" var="cliente"
						itemLabel="#{cliente.nome}" itemValue="#{cliente}"
						converter="genericConverter" forceSelection="true">
						<p:ajax event="itemSelect" update="painel" />
					</p:autoComplete>

					<p:outputLabel value="Documento:  " for="documento" />
					<p:inputText id="documento"
						value="#{lancamentoController.lancamento.documento}"
						disabled="#{!lancamentoController.ativo}" />

					<p:outputLabel value="Descrição: " for="descricao" />
					<p:inputText id="descricao" size="70"
						value="#{lancamentoController.lancamento.descricao}"
						disabled="#{!lancamentoController.ativo}" />

					<p:outputLabel />
					<p:outputLabel />

					<p:outputLabel />
					<p:selectOneRadio disabled="#{!lancamentoController.ativo}"
						id="opcao" value="#{lancamentoController.opcao}">
						<f:selectItem itemLabel="Fixo" itemValue="1" />
						<f:selectItem itemLabel="Parcelado" itemValue="2" />
					</p:selectOneRadio>
					<p:outputLabel />
					<p:selectOneRadio disabled="#{!lancamentoController.ativo}"
						id="tipolancamento" required="true" requiredMessage="Informe um tipo de Lancamento"
						value="#{lancamentoController.lancamento.tipoLancamento}">
						<f:selectItem itemLabel="A Receber" itemValue="R" />
					</p:selectOneRadio>

					<p:outputLabel value="Valor: " for="valor" />
					<p:inputText disabled="#{!lancamentoController.ativo}" id="valor"
						placeholder="ex: 15,20" onkeydown="mascara(this,moeda)"
						value="#{lancamentoController.lancamento.valor}" >
						<f:convertNumber />	
					</p:inputText>

					<p:outputLabel value="Vencimento: " for="vencimento" />
					<p:calendar id="vencimento" pattern="dd/MM/yyyy"
						value="#{lancamentoController.lancamento.dataVencimento}"
						mask="true" disabled="#{!lancamentoController.ativo}" />

					<p:outputLabel value="Condição de Pagamento: " />
					<p:selectOneMenu id="condicaoPagamento"
						value="#{lancamentoController.lancamento.condicaoPagamento}"
						disabled="#{!lancamentoController.ativo}"
						converter="genericConverter">
						<f:selectItems
							value="#{lancamentoController.condicaoDePagamentos}"
							var="condicao" itemLabel="#{condicao.nomeCondicao}"
							itemValue="#{condicao}" />
					</p:selectOneMenu>
					<p:outputLabel />
				</p:panelGrid>
			</h:form>
		</p:tab>
		
		<p:tab title="Lancamentos a Pagar">
			<h:form id="frmCad">
				<p:panel>
					<p:toolbar id="tbOpcoes" style="margin-top: 20px">
						<p:toolbarGroup>
							<p:commandButton value="Salvar" id="botaoSalvar"
								styleClass="corVerde" action="#{lancamentoController.salvar}"
								rendered="#{lancamentoController.ativo}"
								update="frmCad :frmTotais:painel-result growl"
								process="@this painel" />

							<p:commandButton value="Novo" id="botaoNovo" styleClass="corAzul"
								actionListener="#{lancamentoController.ativar}"
								rendered="#{!lancamentoController.ativo}"
								update="tbOpcoes painel growl" process="@this" />

							<p:commandButton value="Cancelar" id="botaoCancelar"
								styleClass="corVermelho"
								rendered="#{lancamentoController.ativo}"
								actionListener="#{lancamentoController.desativar}"
								update="tbOpcoes painel" process="@this">
								<p:resetInput target="painel" />
							</p:commandButton>
						</p:toolbarGroup>
					</p:toolbar>
				</p:panel>
				<p:panelGrid columns="4" id="painel" style="margin-top: 20px"
					styleClass="semBorda">

					<p:outputLabel value="Fornecedor: " for="fornecedor" />
					<p:autoComplete id="fornecedor"
						disabled="#{!lancamentoController.ativo}"
						completeMethod="#{lancamentoController.listarFornecedores}" size="80"
						value="#{lancamentoController.lancamento.cliente}" var="cliente"
						itemLabel="#{cliente.nome}" itemValue="#{cliente}"
						converter="genericConverter" forceSelection="true">
						<p:ajax event="itemSelect" update="painel" />
					</p:autoComplete>

					<p:outputLabel value="Documento:  " for="documento" />
					<p:inputText id="documento"
						value="#{lancamentoController.lancamento.documento}"
						disabled="#{!lancamentoController.ativo}" />

					<p:outputLabel value="Descrição: " for="descricao" />
					<p:inputText id="descricao" size="70"
						value="#{lancamentoController.lancamento.descricao}"
						disabled="#{!lancamentoController.ativo}" />

					<p:outputLabel />
					<p:outputLabel />

					<p:outputLabel />
					<p:selectOneRadio disabled="#{!lancamentoController.ativo}"
						id="opcao" value="#{lancamentoController.opcao}">
						<f:selectItem itemLabel="Fixo" itemValue="1" />
						<f:selectItem itemLabel="Parcelado" itemValue="2" />
					</p:selectOneRadio>
					<p:outputLabel />
					<p:selectOneRadio disabled="#{!lancamentoController.ativo}"
						id="tipolancamento" required="true" requiredMessage="Informe um tipo de Lancamento"
						value="#{lancamentoController.lancamento.tipoLancamento}">
						<f:selectItem itemLabel="A Pagar" itemValue="P" />
					</p:selectOneRadio>

					<p:outputLabel value="Valor: " for="valor" />
					<p:inputText disabled="#{!lancamentoController.ativo}" id="valor"
						placeholder="ex: 15,20" onkeydown="mascara(this,moeda)"
						value="#{lancamentoController.lancamento.valor}" >
						<f:convertNumber />	
					</p:inputText>

					<p:outputLabel value="Vencimento: " for="vencimento" />
					<p:calendar id="vencimento" pattern="dd/MM/yyyy"
						value="#{lancamentoController.lancamento.dataVencimento}"
						mask="true" disabled="#{!lancamentoController.ativo}" />

					<p:outputLabel value="Condição de Pagamento: " />
					<p:selectOneMenu id="condicaoPagamento"
						value="#{lancamentoController.lancamento.condicaoPagamento}"
						disabled="#{!lancamentoController.ativo}"
						converter="genericConverter">
						<f:selectItems
							value="#{lancamentoController.condicaoDePagamentos}"
							var="condicao" itemLabel="#{condicao.nomeCondicao}"
							itemValue="#{condicao}" />
					</p:selectOneMenu>
					<p:outputLabel />
				</p:panelGrid>
			</h:form>
		</p:tab>

		<p:tab title="Consulta">
			<h:form id="frmCons">
				<h1>Pesquisar</h1>
				<br />
				<p:panelGrid columns="4" id="panel-consulta"
					style="padding-top: 10px;" styleClass="semBorda">

					<p:outputLabel value="Nome:" />
					<p:inputText maxlength="80" size="60"
						value="#{lancamentoController.pesquisaLancamento.nomeCliente}" />
					<p:outputLabel value="Documento: " />
					<p:inputText maxlength="80"
						value="#{lancamentoController.pesquisaLancamento.documento}" />

					<p:outputLabel />
					<p:selectOneRadio id="opcaoPesquisa"
						value="#{lancamentoController.pesquisaLancamento.opcao}"
						required="true"
						requiredMessage="Selecione uma opção para o filtro de Operação">
						<f:selectItem itemLabel="Operação" itemValue="1" />
						<f:selectItem itemLabel="Vencimento" itemValue="2" />
					</p:selectOneRadio>
					<p:outputLabel />
					<p:selectOneRadio id="tipoLancamentoPesquisa"
						value="#{lancamentoController.pesquisaLancamento.tipoLancamento}"
						required="true"
						requiredMessage="Selecione uma opção para o filtro de Lançamentos">
						<f:selectItem itemLabel="Todos" itemValue="T" />
						<f:selectItem itemLabel="A Pagar" itemValue="P" />
						<f:selectItem itemLabel="A Receber" itemValue="R" />
					</p:selectOneRadio>

					<p:outputLabel value="Data Inicial:" />
					<p:calendar id="inicial" pattern="dd/MM/yyyy"
						value="#{lancamentoController.pesquisaLancamento.dateIncial}"
						mask="true" />
					<p:outputLabel value="Data Final: " />
					<p:calendar id="final" pattern="dd/MM/yyyy"
						value="#{lancamentoController.pesquisaLancamento.dateFinal}"
						mask="true" />
				</p:panelGrid>

				<center>
					<p:commandButton value="Buscar" id="buscar"
						actionListener="#{lancamentoController.consutaDeLancamentos}"
						update=":tabLancamentos:frmCons:tblLancamento growl"
						process="@this :tabLancamentos:frmCons:panel-consulta" />
				</center>

				<p:dataTable id="tblLancamento"
					emptyMessage="Nenhum Lancamento Listado..."
					value="#{lancamentoController.listaLancamento}"
					style="margin-top: 20px" var="lancamentos" scrollable="true"
					scrollHeight="40%" reflow="true"
					rowStyleClass="#{lancamentos.dataBaixa != null ? 'baixado' :
			    							 lancamentoController.dataAtual > lancamentos.dataVencimento ? 'vencido' : null}">

					<p:column headerText="Documento: " width="10%">
						<h:outputText value="#{lancamentos.documento}" />
					</p:column>

					<p:column headerText="Descrição: " width="20%" footerText="Total:">
						<h:outputText value="#{lancamentos.observacao}" />
					</p:column>

					<p:column headerText="Valor: "
						footerText="#{lancamentoController.valorTotalDosLancamento}">
						<h:outputText value="#{lancamentos.valor}">
							<f:convertNumber type="currency" currencySymbol="R$"
								locale="pt_BR" />
						</h:outputText>
					</p:column>

					<p:column headerText="Cliente: " width="21%">
						<h:outputText value="#{lancamentos.cliente.nome}" />
					</p:column>

					<p:column headerText="Data Operação: ">
						<h:outputText value="#{lancamentos.dataOperacao}">
							<f:convertDateTime locale="pt_BR" pattern="dd/MM/yyyy" />
						</h:outputText>
					</p:column>

					<p:column headerText="Data Vencimento: ">
						<h:outputText value="#{lancamentos.dataVencimento}">
							<f:convertDateTime locale="pt_BR" pattern="dd/MM/yyyy" />
						</h:outputText>
					</p:column>
					
					<p:column headerText="Tipo: " width="50">
						<h:outputText value="#{lancamentos.tipoLancamento}"/>
					</p:column>

					<p:column headerText="Ações" width="90">
						<p:commandButton icon="ui-icon-trash" title="Excluir"
							actionListener="#{lancamentoController.excluir}"
							update=":tabLancamentos:frmCons:tblLancamento growl :frmTotais:painel-result"
							disabled="#{(lancamentos.dataBaixa != null) || (lancamentos.movimento.id != null)}">
							<p:confirm header="Confirmar"
								message="Desenja excluir o Titulo ?" icon="ui-icon-alert" />
							<f:attribute name="lancamentoExcluido" value="#{lancamentos}" />
						</p:commandButton>

						<p:commandButton icon="ui-icon-check" title="Baixar"
							actionListener="#{lancamentoController.lancamentoBaixaPacialOuTotal}"
							onclick="PF('dlgOpcoes').show();"
							disabled="#{lancamentos.dataBaixa != null ? true : false}">
							<f:attribute name="tituloBaixado" value="#{lancamentos}" />
						</p:commandButton>
					</p:column>

					<f:facet name="footer">
						<h:outputText value="A Consuta resultou em:  " />
						<h:outputText
							value="#{fn:length(lancamentoController.listaLancamento) == null ? 'Nenhum Lançamento' : fn:length(lancamentoController.listaLancamento)}" />
						<h:outputText
							rendered="#{fn:length(lancamentoController.listaLancamento) == 1 ? true : false}"
							value=" Lançamento cadastrado." />
						<h:outputText
							rendered="#{fn:length(lancamentoController.listaLancamento) > 1 ? true : false}"
							value=" Lançamentos cadastrados." />
					</f:facet>
				</p:dataTable>

				<p:dialog header="Opções: " widgetVar="dlgOpcoes" modal="true"
					height="100">
					<p:outputLabel value="Selecione como quer Baixar o Titulo..." />
					<p:selectOneRadio id="dlgopcao"
						value="#{lancamentoController.opcaoLancamento}" required="true"
						requiredMessage="Selecione uma opção para a Baixa do Titulo:">
						<f:selectItem itemLabel="Total" itemValue="1" />
						<f:selectItem itemLabel="Parcial" itemValue="2" />
						<f:ajax render="valor" />
					</p:selectOneRadio>

					<p:inputText id="valor" placeholder="Sem ponto e virgula."
						disabled="#{lancamentoController.opcaoLancamento == 1}"
						onkeydown="mascara(this,moeda)"
						value="#{lancamentoController.valorBaixaParcial}">
						<f:convertNumber />
					</p:inputText>

					<p:commandButton icon="ui-icon-check" title="Baixar"
						actionListener="#{lancamentoController.baixarTitulo}"
						update=":tabLancamentos:frmCons:tblLancamento growl :frmTotais:painel-result"
						oncomplete="PF('dlgOpcoes').hide();">

					</p:commandButton>
				</p:dialog>


				<p:confirmDialog global="true">
					<p:commandButton value="Sim" type="button"
						styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
					<p:commandButton value="Nao" type="button"
						styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
				</p:confirmDialog>
			</h:form>
		</p:tab>
	</p:tabView>
</ui:composition>